/*
   Class Name:

      CTerrain.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class is a base class used to load and save a terrain.
*/


#ifndef _CTERRAIN_H
#define _CTERRAIN_H


class CHeightMap
{
   public:
      CHeightMap() { mapData = 0; size = 0; }
      ~CHeightMap()
         {
            size = 0;
            if(mapData) delete[] mapData;
            mapData = 0;
         }

      unsigned char *mapData;
      int size;
};


class CTerrain
{
   public:
      CTerrain();
      ~CTerrain();

      bool LoadMap(char *filename);
      bool SaveMap(char *filename);
      void CreateTerrainMesh();

      void SetHeightScale(float val);
      void SetHeight(unsigned char val, int x, int z);
      unsigned char GetHeight(int x, int z);
      float GetScaledHeight(int x, int z);

      void ShutDown();

      // Stores height map and scale value.
      CHeightMap m_heightMap;
      float m_heightScale;

      // Vertex list and vertex colors.
      float *m_terrainMesh;
      float *m_vertexColor;

      int m_totalVerts;
      int m_totalTriangles;
};

#endif


// Copyright July 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com